<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FindUser StructType
 * @subpackage Structs
 */
class FindUser extends AbstractStructBase
{
    /**
     * The count
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $count;
    /**
     * The next
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $next;
    /**
     * The nohide
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $nohide;
    /**
     * The v501
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $v501;
    /**
     * The v700
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $v700;
    /**
     * The v800
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $v800;
    /**
     * The vx1100
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $vx1100;
    /**
     * The cn
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $cn;
    /**
     * The h323
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $h323;
    /**
     * The e164
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $e164;
    /**
     * Constructor method for FindUser
     * @uses FindUser::setCount()
     * @uses FindUser::setNext()
     * @uses FindUser::setNohide()
     * @uses FindUser::setV501()
     * @uses FindUser::setV700()
     * @uses FindUser::setV800()
     * @uses FindUser::setVx1100()
     * @uses FindUser::setCn()
     * @uses FindUser::setH323()
     * @uses FindUser::setE164()
     * @param int $count
     * @param int $next
     * @param bool $nohide
     * @param string $v501
     * @param string $v700
     * @param string $v800
     * @param string $vx1100
     * @param string $cn
     * @param string $h323
     * @param string $e164
     */
    public function __construct($count = null, $next = null, $nohide = null, $v501 = null, $v700 = null, $v800 = null, $vx1100 = null, $cn = null, $h323 = null, $e164 = null)
    {
        $this
            ->setCount($count)
            ->setNext($next)
            ->setNohide($nohide)
            ->setV501($v501)
            ->setV700($v700)
            ->setV800($v800)
            ->setVx1100($vx1100)
            ->setCn($cn)
            ->setH323($h323)
            ->setE164($e164);
    }
    /**
     * Get count value
     * @return int
     */
    public function getCount()
    {
        return $this->count;
    }
    /**
     * Set count value
     * @param int $count
     * @return \StructType\FindUser
     */
    public function setCount($count = null)
    {
        // validation for constraint: int
        if (!is_null($count) && !is_numeric($count)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($count)), __LINE__);
        }
        $this->count = $count;
        return $this;
    }
    /**
     * Get next value
     * @return int
     */
    public function getNext()
    {
        return $this->next;
    }
    /**
     * Set next value
     * @param int $next
     * @return \StructType\FindUser
     */
    public function setNext($next = null)
    {
        // validation for constraint: int
        if (!is_null($next) && !is_numeric($next)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($next)), __LINE__);
        }
        $this->next = $next;
        return $this;
    }
    /**
     * Get nohide value
     * @return bool
     */
    public function getNohide()
    {
        return $this->nohide;
    }
    /**
     * Set nohide value
     * @param bool $nohide
     * @return \StructType\FindUser
     */
    public function setNohide($nohide = null)
    {
        // validation for constraint: boolean
        if (!is_null($nohide) && !is_bool($nohide)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($nohide)), __LINE__);
        }
        $this->nohide = $nohide;
        return $this;
    }
    /**
     * Get v501 value
     * @return string|null
     */
    public function getV501()
    {
        return $this->v501;
    }
    /**
     * Set v501 value
     * @param string $v501
     * @return \StructType\FindUser
     */
    public function setV501($v501 = null)
    {
        // validation for constraint: string
        if (!is_null($v501) && !is_string($v501)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($v501)), __LINE__);
        }
        $this->v501 = $v501;
        return $this;
    }
    /**
     * Get v700 value
     * @return string|null
     */
    public function getV700()
    {
        return $this->v700;
    }
    /**
     * Set v700 value
     * @param string $v700
     * @return \StructType\FindUser
     */
    public function setV700($v700 = null)
    {
        // validation for constraint: string
        if (!is_null($v700) && !is_string($v700)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($v700)), __LINE__);
        }
        $this->v700 = $v700;
        return $this;
    }
    /**
     * Get v800 value
     * @return string|null
     */
    public function getV800()
    {
        return $this->v800;
    }
    /**
     * Set v800 value
     * @param string $v800
     * @return \StructType\FindUser
     */
    public function setV800($v800 = null)
    {
        // validation for constraint: string
        if (!is_null($v800) && !is_string($v800)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($v800)), __LINE__);
        }
        $this->v800 = $v800;
        return $this;
    }
    /**
     * Get vx1100 value
     * @return string|null
     */
    public function getVx1100()
    {
        return $this->vx1100;
    }
    /**
     * Set vx1100 value
     * @param string $vx1100
     * @return \StructType\FindUser
     */
    public function setVx1100($vx1100 = null)
    {
        // validation for constraint: string
        if (!is_null($vx1100) && !is_string($vx1100)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($vx1100)), __LINE__);
        }
        $this->vx1100 = $vx1100;
        return $this;
    }
    /**
     * Get cn value
     * @return string|null
     */
    public function getCn()
    {
        return $this->cn;
    }
    /**
     * Set cn value
     * @param string $cn
     * @return \StructType\FindUser
     */
    public function setCn($cn = null)
    {
        // validation for constraint: string
        if (!is_null($cn) && !is_string($cn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cn)), __LINE__);
        }
        $this->cn = $cn;
        return $this;
    }
    /**
     * Get h323 value
     * @return string|null
     */
    public function getH323()
    {
        return $this->h323;
    }
    /**
     * Set h323 value
     * @param string $h323
     * @return \StructType\FindUser
     */
    public function setH323($h323 = null)
    {
        // validation for constraint: string
        if (!is_null($h323) && !is_string($h323)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($h323)), __LINE__);
        }
        $this->h323 = $h323;
        return $this;
    }
    /**
     * Get e164 value
     * @return string|null
     */
    public function getE164()
    {
        return $this->e164;
    }
    /**
     * Set e164 value
     * @param string $e164
     * @return \StructType\FindUser
     */
    public function setE164($e164 = null)
    {
        // validation for constraint: string
        if (!is_null($e164) && !is_string($e164)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($e164)), __LINE__);
        }
        $this->e164 = $e164;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\FindUser
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
