<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LocationUrl StructType
 * @subpackage Structs
 */
class LocationUrl extends AbstractStructBase
{
    /**
     * The tls
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $tls;
    /**
     * The v501
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $v501;
    /**
     * The v700
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $v700;
    /**
     * The v800
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $v800;
    /**
     * The vx1100
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $vx1100;
    /**
     * The loc
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $loc;
    /**
     * Constructor method for LocationUrl
     * @uses LocationUrl::setTls()
     * @uses LocationUrl::setV501()
     * @uses LocationUrl::setV700()
     * @uses LocationUrl::setV800()
     * @uses LocationUrl::setVx1100()
     * @uses LocationUrl::setLoc()
     * @param bool $tls
     * @param string $v501
     * @param string $v700
     * @param string $v800
     * @param string $vx1100
     * @param string $loc
     */
    public function __construct($tls = null, $v501 = null, $v700 = null, $v800 = null, $vx1100 = null, $loc = null)
    {
        $this
            ->setTls($tls)
            ->setV501($v501)
            ->setV700($v700)
            ->setV800($v800)
            ->setVx1100($vx1100)
            ->setLoc($loc);
    }
    /**
     * Get tls value
     * @return bool
     */
    public function getTls()
    {
        return $this->tls;
    }
    /**
     * Set tls value
     * @param bool $tls
     * @return \StructType\LocationUrl
     */
    public function setTls($tls = null)
    {
        // validation for constraint: boolean
        if (!is_null($tls) && !is_bool($tls)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($tls)), __LINE__);
        }
        $this->tls = $tls;
        return $this;
    }
    /**
     * Get v501 value
     * @return string|null
     */
    public function getV501()
    {
        return $this->v501;
    }
    /**
     * Set v501 value
     * @param string $v501
     * @return \StructType\LocationUrl
     */
    public function setV501($v501 = null)
    {
        // validation for constraint: string
        if (!is_null($v501) && !is_string($v501)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($v501)), __LINE__);
        }
        $this->v501 = $v501;
        return $this;
    }
    /**
     * Get v700 value
     * @return string|null
     */
    public function getV700()
    {
        return $this->v700;
    }
    /**
     * Set v700 value
     * @param string $v700
     * @return \StructType\LocationUrl
     */
    public function setV700($v700 = null)
    {
        // validation for constraint: string
        if (!is_null($v700) && !is_string($v700)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($v700)), __LINE__);
        }
        $this->v700 = $v700;
        return $this;
    }
    /**
     * Get v800 value
     * @return string|null
     */
    public function getV800()
    {
        return $this->v800;
    }
    /**
     * Set v800 value
     * @param string $v800
     * @return \StructType\LocationUrl
     */
    public function setV800($v800 = null)
    {
        // validation for constraint: string
        if (!is_null($v800) && !is_string($v800)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($v800)), __LINE__);
        }
        $this->v800 = $v800;
        return $this;
    }
    /**
     * Get vx1100 value
     * @return string|null
     */
    public function getVx1100()
    {
        return $this->vx1100;
    }
    /**
     * Set vx1100 value
     * @param string $vx1100
     * @return \StructType\LocationUrl
     */
    public function setVx1100($vx1100 = null)
    {
        // validation for constraint: string
        if (!is_null($vx1100) && !is_string($vx1100)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($vx1100)), __LINE__);
        }
        $this->vx1100 = $vx1100;
        return $this;
    }
    /**
     * Get loc value
     * @return string|null
     */
    public function getLoc()
    {
        return $this->loc;
    }
    /**
     * Set loc value
     * @param string $loc
     * @return \StructType\LocationUrl
     */
    public function setLoc($loc = null)
    {
        // validation for constraint: string
        if (!is_null($loc) && !is_string($loc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($loc)), __LINE__);
        }
        $this->loc = $loc;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\LocationUrl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
