<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SetPresence StructType
 * @subpackage Structs
 */
class SetPresence extends AbstractStructBase
{
    /**
     * The im
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $im;
    /**
     * The presence
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Presence
     */
    public $presence;
    /**
     * The contact
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $contact;
    /**
     * The guid
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $guid;
    /**
     * The h323
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $h323;
    /**
     * Constructor method for SetPresence
     * @uses SetPresence::setIm()
     * @uses SetPresence::setPresence()
     * @uses SetPresence::setContact()
     * @uses SetPresence::setGuid()
     * @uses SetPresence::setH323()
     * @param bool $im
     * @param \StructType\Presence $presence
     * @param string $contact
     * @param string $guid
     * @param string $h323
     */
    public function __construct($im = null, \StructType\Presence $presence = null, $contact = null, $guid = null, $h323 = null)
    {
        $this
            ->setIm($im)
            ->setPresence($presence)
            ->setContact($contact)
            ->setGuid($guid)
            ->setH323($h323);
    }
    /**
     * Get im value
     * @return bool
     */
    public function getIm()
    {
        return $this->im;
    }
    /**
     * Set im value
     * @param bool $im
     * @return \StructType\SetPresence
     */
    public function setIm($im = null)
    {
        // validation for constraint: boolean
        if (!is_null($im) && !is_bool($im)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($im)), __LINE__);
        }
        $this->im = $im;
        return $this;
    }
    /**
     * Get presence value
     * @return \StructType\Presence|null
     */
    public function getPresence()
    {
        return $this->presence;
    }
    /**
     * Set presence value
     * @param \StructType\Presence $presence
     * @return \StructType\SetPresence
     */
    public function setPresence(\StructType\Presence $presence = null)
    {
        $this->presence = $presence;
        return $this;
    }
    /**
     * Get contact value
     * @return string|null
     */
    public function getContact()
    {
        return $this->contact;
    }
    /**
     * Set contact value
     * @param string $contact
     * @return \StructType\SetPresence
     */
    public function setContact($contact = null)
    {
        // validation for constraint: string
        if (!is_null($contact) && !is_string($contact)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($contact)), __LINE__);
        }
        $this->contact = $contact;
        return $this;
    }
    /**
     * Get guid value
     * @return string|null
     */
    public function getGuid()
    {
        return $this->guid;
    }
    /**
     * Set guid value
     * @param string $guid
     * @return \StructType\SetPresence
     */
    public function setGuid($guid = null)
    {
        // validation for constraint: string
        if (!is_null($guid) && !is_string($guid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($guid)), __LINE__);
        }
        $this->guid = $guid;
        return $this;
    }
    /**
     * Get h323 value
     * @return string|null
     */
    public function getH323()
    {
        return $this->h323;
    }
    /**
     * Set h323 value
     * @param string $h323
     * @return \StructType\SetPresence
     */
    public function setH323($h323 = null)
    {
        // validation for constraint: string
        if (!is_null($h323) && !is_string($h323)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($h323)), __LINE__);
        }
        $this->h323 = $h323;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SetPresence
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
